<?php


/**
 * Abtrackte Basisklasse fr REX_VARS
 * @package redaxo4
 * @version $Id: class.rex_var.inc.php,v 1.19 2007/10/13 13:52:00 kills Exp $
 */

class rex_var
{
  // --------------------------------- Actions

  /**
   * Actionmethode:
   * Zum fllen des sql aus dem $REX_ACTION Array
   */
  function setACValues(& $sql, $REX_ACTION, $escape = false)
  {
    // nichts tun
  }

  /**
   * Actionmethode:
   * Zum fllen des $REX_ACTION Arrays aus den Input Formularwerten
   * @return REX_ACTION Array
   */
  function getACRequestValues($REX_ACTION)
  {
    return $REX_ACTION;
  }

  /**
   * Actionmethode:
   * Zum fllen des $REX_ACTION Arrays aus der Datenbank (rex_sql)
   * @return REX_ACTION Array
   */
  function getACDatabaseValues($REX_ACTION, & $sql)
  {
    return $REX_ACTION;
  }

  /**
   * Actionmethode:
   * Ersetzen der Werte in dem Aktionsscript
   * @return output String
   */
  function getACOutput($REX_ACTION, $content)
  {
    $sql = new rex_sql();
    $this->setACValues($sql, $REX_ACTION);
    return $this->getBEOutput($sql, $content);
  }

  // --------------------------------- Ouput

  /**
   * Ausgabe eines Modules frs Frontend
   * sql Objekt mit der passenden Slice
   *
   * FE = Frontend
   */
  function getFEOutput(& $sql, $content)
  {
    return $this->getBEOutput($sql, $content);
  }

  /**
   * Ausgabe eines Modules im Backend bei der Ausgabe
   * sql Objekt mit der passenden Slice
   *
   * BE = Backend
   */
  function getBEOutput(& $sql, $content)
  {
    return $content;
  }

  /**
   * Ausgabe eines Modules im Backend bei der Eingabe
   * sql Objekt mit der passenden Slice
   *
   * BE = Backend
   */
  function getBEInput(& $sql, $content)
  {
    return $this->getBEOutput($sql, $content);
  }

  /**
   * Ausgabe eines Templates
   */
  function getTemplate($content)
  {
  	return $content;
  }

  /**
   * Wandelt PHP Code in Einfache Textausgaben um
   */
  function stripPHP($content)
  {
    $content = str_replace('<?', '&lt;?', $content);
    $content = str_replace('?>', '?&gt;', $content);
    return $content;
  }

  /**
   * GetValue Wrapper, da hier immer auf die gleiche Tabelle gearbeitet wird und
   * mit MySQL 3.x mit Tabellenprefix angegeben werden muss, da der SQL gleichnamige
   * Spalten unterschiedlicher Tabellen enthlt.
   */
  function getValue(& $sql, $value)
  {
    global $REX;
    return $sql->getValue($REX['TABLE_PREFIX'] . 'article_slice.' . $value);
  }
  /**
   * setValue Wrapper, da hier immer auf die gleiche Tabelle gearbeitet wird und
   * mit MySQL 3.x mit Tabellenprefix angegeben werden muss, da der SQL gleichnamige
   * Spalten unterschiedlicher Tabellen enthlt.
   */
  function setValue(& $sql, $fieldname, $value, $escape = false)
  {
    global $REX;

    if($escape)
      return $sql->setValue($REX['TABLE_PREFIX'] . 'article_slice.' . $fieldname, addslashes($value));

    return $sql->setValue($REX['TABLE_PREFIX'] . 'article_slice.' . $fieldname, $value);
  }

  /**
   * Findet den Parameter einer Variable in der Ausgabe.
   * Da dort immer nur ein ID Feld sinnvoll ist, wird das ganze hier in der
   * Basisklasse gemacht.
   * @access protected
   */
  function getOutputParam($content, $varname)
  {
    $result = array ();

    $match = $this->matchVar($content, $varname);
    foreach ($match as $param_str)
    {
      $params = $this->splitString($param_str);

      $id = '';
      foreach ($params as $name => $value)
      {
        switch ($name)
        {
          case '0' :
          case 'id' :
            $id = (int) $value;
            break;
        }
      }

      if ($id != '')
      {
        $result[] = array (
          $param_str,
          $id
        );
      }
    }

    return $result;
  }

  /**
   * Durchsucht den String $content nach Variablen mit dem Namen $varname.
   * Gibt die Parameter der Treffer (Text der Variable zwischen den []) als Array zurck.
   */
  function matchVar($content, $varname)
  {
    $result = array ();

    if (preg_match_all('/' . $varname . '\[([^\]]*)\]/ms', $content, $matches))
    {
      foreach ($matches[1] as $match)
      {
        $result[] = $match;
      }
    }

    return $result;
  }

  /**
   * Trennt einen String an Leerzeichen auf.
   * Abschnitte die in "" oder '' stehen, werden als ganzes behandelt und
   * darin befindliche Leerzeichen nicht getrennt.
   * @access protected
   */
  function splitString($string)
  {
    $spacer = '@@@REX_SPACER@@@';
    $result = array ();

    // TODO mehrfachspaces hintereinander durch einfachen ersetzen
    $string = ' ' . trim($string) . ' ';

    // Strings mit Quotes heraussuchen
    preg_match_all('!(["\'])(.*)\\1!', $string, $matches);
    $quoted = isset ($matches[2]) ? $matches[2] : array ();

    // Strings mit Quotes maskieren
    $string = preg_replace('!(["\'])(.*)\\1!', $spacer, $string);

    // ----------- z.b. 4 "av c" 'de f' ghi
    if (strpos($string, '=') === false)
    {
      $parts = explode(' ', $string);
      foreach ($parts as $part)
      {
        if (empty ($part))
          continue;

        if ($part == $spacer)
        {
          $result[] = array_shift($quoted);
        }
        else
        {
          $result[] = $part;
        }
      }
    }
    // ------------ z.b. a=4 b="av c" y='de f' z=ghi
    else
    {
      $parts = explode(' ', $string);
      foreach ($parts as $part)
      {
      	if(empty($part))
      		continue;

        $variable = explode('=', $part);
        $var_name = $variable[0];
        $var_value = $variable[1];

        if (empty ($var_name))
          continue;

        if ($var_value == $spacer)
        {
          $var_value = array_shift($quoted);
        }

        $result[$var_name] = $var_value;
      }
    }
    return $result;
  }

  function isAddEvent()
  {
    return (rex_request('btn_save', 'string') != '') && rex_request('function', 'string') == 'add';
  }

  function isEditEvent()
  {
    return (rex_request('btn_update', 'string') != '' || rex_request('btn_save', 'string') != '') && rex_request('function', 'string') == 'edit';
  }

  function isDeleteEvent()
  {
    return rex_request('function', 'string') == 'delete';
  }
}
?>